/* vtetris.c
 *
 * THIS SOFTWARE IS COPYRIGHT UNDER THE GPL. PLEASE GO THROUGH THE LICENCE
 * ALONGWITH README FOR COMPLETE DETAILS.
 *
 * (C) - VISHWESHWAR SARAN SINGH DEO
 *	 ALL RIGHTS RESERVED.
 */

#include "objects.c"
#define maxtime 55989700

int timer();
int engine();
int enginelr();
int getinit();
int result();

main()
{
   /* MESSAGE AND WELCOME PART */
   fullwin=initscr();
   start_color();cbreak();noecho();
   
   nextwin=newwin(11, 55, 7, 12);
   init_pair(1,COLOR_WHITE,COLOR_BLUE);
   init_pair(2,COLOR_WHITE, COLOR_BLACK);
   wattrset(nextwin, COLOR_PAIR(1));
   box(nextwin,0,0);
   wattrset(nextwin, COLOR_PAIR(2));
   mvwprintw(nextwin, 2,5,"Welcome to V-tetris !");
   mvwprintw(nextwin, 4,5, "Vishweshwar's Tetris Version: beta-1.0.0");
   mvwprintw(nextwin, 6,5, "(C) Copyright by: Vishweshwar Saran Singh Deo");
   mvwprintw(nextwin, 7,5, "All Rights Reserved First Release: 11/10/1999");
   mvwprintw(nextwin, 8,5, "Copyright Held Under GPL 1999-");
   mvwprintw(fullwin,23,18, "PLEASE GO THROUGH THE README & LICENCE");
   mvaddstr(21,22, "Press Enter Key To Proceed ...");
   wrefresh(fullwin);
   wrefresh(nextwin);
   wgetch(nextwin);
   wrefresh(nextwin);
   endwin();

   /* -----------END----------*/

   win1=initscr();
   start_color();
   
   cbreak(); noecho(); nonl(); 
   intrflush(win1, FALSE);
   keypad(win1, TRUE);

   win1=newwin(25,70,0,0 );
   swin1=subwin(win1,25,1,0,10);
   swin2=subwin(win1,5,60,0,10);
   wrefresh(win1);

   for (loop1=0; loop1 <=23; loop1++)
      for (loop2=0; loop2 <=9;loop2++)
      matrix[loop1][loop2]='0';

   for (loop1=0; loop1<=9; loop1++)
      matrix[23][loop1]='*';

   init_pair(1,COLOR_WHITE, COLOR_BLUE );
   init_pair(2,COLOR_WHITE, COLOR_BLACK);
   init_pair(3,COLOR_WHITE, COLOR_RED);
   init_pair(4,COLOR_MAGENTA, COLOR_BLACK);
   init_pair(5,COLOR_WHITE, COLOR_YELLOW);
   init_pair(6,COLOR_WHITE, COLOR_BLUE);
   init_pair(7,COLOR_BLACK, COLOR_BLACK);
   init_pair(8,COLOR_BLACK, COLOR_YELLOW);
   init_pair(9,COLOR_BLACK, COLOR_GREEN);


   wattrset(win1, COLOR_PAIR(1)| A_BOLD);
   wattrset(swin1, COLOR_PAIR(1)| A_BOLD);
   wattrset(swin2, COLOR_PAIR(1)| A_BOLD);

   box(win1,0,0);
   box(swin1,0,0);
   box(swin2,0,0);
   touchwin(swin1);
/*   wrefresh(swin1);*/
   engine();

   while (y < stop.row)
   {
      nodelay(win1, TRUE);
/*      keypad(win1,TRUE);*/
      if ((c=wgetch(win1)) != ERR)
      {
	 keypress(c);
      }

      nodelay(win1, TRUE);	
      keypad(win1,TRUE);
      if ((c=wgetch(win1)) != ERR)
      {
          keypress(c);
      }
      	  
      
      keypad(win1, TRUE);
      engine();
/* ---Messages--- */
      msg();

      wattrset(win1, COLOR_PAIR(1)| A_BOLD);
/*-----*/
      objects (o_pt.row, o_pt.col, 1 );getpos();
      wrefresh(win1);
      timer();
      if (o_pt.row != stop.row)
      {  objects (o_pt.row, o_pt.col ,0);  }
      wmove(win1,o_pt.row, o_pt.col); /* This is to keep col in place */

      score();
      selcheck();
      o_pt.row++;
   }

   endwin();
}


timer()
{
   long  time;
   for (time=0; time<=maxtime; time++)
   {  }
}



engine()
{
   int eloop1, eloop2, fx,fy,bcount,end=1;

   if (sel==1)
   {
      if (ori==1)
      {
	 fy=o_pt.row; fx=o_pt.col; limit=o_pt.col+4; fyy=o_pt.row;
      }
      if (ori==2)
      {
	 fy=o_pt.row; fx=o_pt.col; limit=o_pt.col+1; fyy=o_pt.row;
      }
   }

   if (sel==2)
   {
      fy=o_pt.row-1; fx=o_pt.col-1; limit=o_pt.col+1; fyy=o_pt.row-1;
   }

   if (sel==3)
   {
      if (ori==1)
      {  fy=o_pt.row; fx=o_pt.col-2; limit=o_pt.col+1; fyy=o_pt.row;  }

      if (ori==2)
      {  fy=o_pt.row; fx=o_pt.col-3; limit=o_pt.col+1;fyy=o_pt.row;  }

      if (ori==3)
      {  fy=o_pt.row-2; fx=o_pt.col-2; limit=o_pt.col+1; fyy=o_pt.row-2;  }

      if (ori==4)
      {  fy=o_pt.row-1; fx=o_pt.col; limit=o_pt.col+4;fyy=o_pt.row-1;  }
   }
/*----*/
   if (sel==4)
   {
      if (ori==1)
      {  fy=o_pt.row; fx=o_pt.col; limit=o_pt.col+3; fyy=o_pt.row;  }

      if (ori==2)
      {  fy=o_pt.row-1; fx=o_pt.col-3; limit=o_pt.col+1;fyy=o_pt.row-1;  }

      if (ori==3)
      {
	 fy=o_pt.row-2;fx=o_pt.col; limit=o_pt.col+3; fyy=o_pt.row-2;
	 save[3]=0; save[3]=23;
      }
      if (ori==4)
      {  fy=o_pt.row; fx=o_pt.col; limit=o_pt.col+4;fyy=o_pt.row;  }
   }

   sy=0;sx=0;

   while (fx  != limit)
   {
      while  (end != 0)
      {
	 if (matrix[fy][fx] == '*')
	 {
	    wattrset(win1, COLOR_PAIR(2)| A_BOLD);
	    save[sy]=fy;
	    savec[sx]=fx;
	    sy++;  sx++;break;
	 }
	 fy++;
      }
      fy=fyy;
      fx++;
   }
result();
}

smallest(int gsave[4], int option, char dir)
{
   if (dir == 'l')
   {

      if (option==2)
      {
	 if ( gsave[0] < gsave[1] )
	    return(gsave[0]);
	 else return (gsave[1]);
      }

      if (option==3)
      {
	 if ((gsave[0] <= gsave[1]) && (gsave[0] <= gsave[2]))
	    return(gsave[0]);

	 if ((gsave[1] <= gsave[0]) && (gsave[1] <= gsave[2]))
	    return(gsave[1]);

	 if ((gsave[2] <= gsave[0]) && (gsave[2] <= gsave[1]))
	    return(gsave[2]);
            

      }
   }

   if (dir=='r')
   {
      if (option==2)
      {
	 if ( gsave[3] < gsave[2] )
	    return(gsave[3]);
	 else return (gsave[2]);
      }

      if (option==3)
      {

	 if ((gsave[3] <= gsave[2]) && (gsave[3] <= gsave[1]))
	    return(gsave[3]);

	 if ((gsave[2] <= gsave[3]) && (gsave[2] <= gsave[1]))
	    return(gsave[2]);

	 if ((gsave[1] <= gsave[3]) && (gsave[1] <= gsave[2]))
	    return(gsave[1]);

      }

   }
   dir=' ';
}

/* Left Movement Control Area */
keypress(int c)

{
   if(c==KEY_LEFT )
   {
      if (sel==1)
      {
	 if (ori==1)
	 {
	    if((matrix[o_pt.row][o_pt.col-1] != '*') &&
	       (o_pt.col-1 >=1))
	    {  o_pt.col--;sel=0;  }
	 }
	 if (ori==2)
	 {
	    if((matrix[o_pt.row][o_pt.col-1] != '*' ) &&
	       (matrix[o_pt.row-1][o_pt.col-1] != '*' ) &&
	       (matrix[o_pt.row-2][o_pt.col-1] != '*' ) &&
	       (matrix[o_pt.row-3][o_pt.col-1] != '*' ) &&
	       (o_pt.col-1>=1))
	    {  o_pt.col--;sel=0;  }
	 }
	 sel=1;

      }


      if (sel==2)
      {
	 if ((matrix[o_pt.row-1][o_pt.col-2] != '*') &&
	    (matrix[o_pt.row][o_pt.col-2] != '*') &&
	    (o_pt.col-2 >=1))
	 {  o_pt.col--;  }
      }


      if (sel==3 && ori==1)
      {
	    if ((matrix[o_pt.row-2][o_pt.col-3] != '*') &&
	    (matrix[o_pt.row-1][o_pt.col-3] != '*')   &&
	    (matrix[o_pt.row][o_pt.col-3] != '*') &&
	    (o_pt.col-1 <=1))
	 {  o_pt.col--;  }
      }
      if (sel==3 && ori==2)
      {
	 if ((matrix[o_pt.row][o_pt.col-4] != '*') &&
/*    (matrix[o_pt.row+1][o_pt.col-4] != '*') &&*/
	 (o_pt.col-4 >=1))
	 {  o_pt.col--;  }
      }

      if (sel==3 && ori==3)
      {
	 if ((matrix[o_pt.row-2][o_pt.col-3] != '*') &&
	    (matrix[o_pt.row-1][o_pt.col-2] != '*') &&
	    (matrix[o_pt.row][o_pt.col-2] !='*') &&
	    (o_pt.col-3 >=1))
	 {  o_pt.col--;  }

      }

      if (sel==3 && ori==4)
      {
	 if ((matrix[o_pt.row-1][o_pt.col-1] != '*') &&
	    (matrix[o_pt.row][o_pt.col-1] != '*') &&
	    (o_pt.col-1 >=1))
	 {  o_pt.col--;  }
      }

      if (sel==4 && ori==1)
      {
	 if ((matrix[o_pt.row-2][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row][o_pt.col-1] != '*' ) &&
	    (o_pt.col-1 >= 1))
	 {  o_pt.col--;  }
      }
      if (sel==4 && ori==2)
      {
	 if ((matrix[o_pt.row][o_pt.col-4] != '*') &&
	    (o_pt.col-4 >= 1))
	 {  o_pt.col--;  }
      }
      if (sel==4 && ori==3)
      {
	 if ((matrix[o_pt.row-2][o_pt.col-1] !='*') &&
	    (matrix[o_pt.row-1][o_pt.col-1] != '*') &&
	    (matrix[o_pt.row][o_pt.col-1] !='*') &&
	    (o_pt.col-1 >=1))
	 {  o_pt.col--;  }
      }
      if (sel==4 && ori==4)
      {
	 if ((matrix[o_pt.row-1][o_pt.col-1] !='*') &&
	    (matrix[o_pt.row][o_pt.col-1] != '*') &&
	    (o_pt.col-1 >=1))
	 {  o_pt.col--;  }
      }


   }
/* Right Movement Control Area */
   if (c==KEY_RIGHT)
   {
      if (sel==1)
      {
	 if (ori==1)
	 {
	    if((matrix[o_pt.row][o_pt.col-1] != '*') &&
	       (o_pt.col+4 <=9))
	    {  o_pt.col++;sel=0;  }
	 }
	 if (ori==2)
	 {
	    if((matrix[o_pt.row][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-3][o_pt.col+1] != '*') &&
	       (o_pt.col+1 <=9))
	    {  o_pt.col++;sel=0;  }
	 }
	 sel=1;
      }

      if (sel==2)
      {
	 if ((matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row][o_pt.col+1] != '*') &&
	    (o_pt.col+1 <=9))
	 {  o_pt.col++;  }
      }
/* For L-type Objects */
      if (sel==3 && ori==1)
      {
	 if (( matrix[o_pt.row][o_pt.col+1] !='*')  &&
	    (matrix[o_pt.row+1][o_pt.col+1] != '*') &&
	    (o_pt.col+1 <=9))
	 {  o_pt.col++;  }
      }
      if (sel==3 && ori==2)
      {

	 if ((matrix[o_pt.row][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row+1][o_pt.col+1] != '*') &&
	    (o_pt.col+1 <=9))

	 {  o_pt.col++;  }

      }
      if (sel==3 && ori==3)
      {
	 if ((matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row+1][o_pt.col+1] != '*') &&
	    (o_pt.col+1 <=9))
	 {  o_pt.col++;  }
      }

      if (sel==3 && ori ==4)
      {
	 if ((matrix[o_pt.row-1][o_pt.col+4] != '*') &&
	    (matrix[o_pt.row][o_pt.col+4] != '*') &&
	    (o_pt.col+4 <=9))
	 {  o_pt.col++;  }
      }
/* End for L-Type of Objects */
      if (sel==4 && ori==1)
      {
	 if ((matrix[o_pt.row-2][o_pt.col+3] != '*') &&
	    (matrix[o_pt.row-1][o_pt.col+3] != '*') &&
	    (matrix[o_pt.row][o_pt.col+3] != '*') &&
	    (o_pt.col+3 <=9))
	 {  o_pt.col++;  }
      }

      if (sel==4 && ori==2)
      {
	 if ((matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	    (matrix[o_pt.row][o_pt.col+1] != '*') &&
	    (o_pt.col+1 <=9))
	 {  o_pt.col++;  }

      }
      if (sel==4 && ori==3)
      {
	 if ((matrix[o_pt.row-2][o_pt.col+3] != '*') &&
	    (matrix[o_pt.row-1][o_pt.col+2] != '*') &&
	    (matrix[o_pt.row][o_pt.col+2] != '*') &&
	    (o_pt.col+3 <=9))
	 {  o_pt.col++;  }

      }
      if (sel==4 && ori==4)
      {
	 if ((matrix[o_pt.row][o_pt.col+4] != '*') &&
	    (matrix[o_pt.row+1][o_pt.col+4] != '*') &&
	    (o_pt.col+4 <=9))
	 {  o_pt.col++;  }

      }


   }
   if(c==KEY_UP )		/* Change Objects */
   {
      if (sel==1)
      {
	 if (sel==1 && ori==1)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col] != '*') &&
	       (matrix[o_pt.row-3][o_pt.col] != '*') &&
	       (o_pt.col-1 >=1))
	    {  ori=2; sel=0;  }
	 }
	 if (sel==1 && ori==2)
	 {
               if((matrix[o_pt.row+1][o_pt.col] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+2] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+3] != '*') &&
	       (o_pt.col+3 <=9))
	    {  ori=1; sel=0;  }

	 }
	 sel=1;
      }



      if (sel==3)
      {
	 if (sel==3 && ori==1)
	 {

	    if((matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row][o_pt.col-1] != '*') &&
	       (matrix[o_pt.row][o_pt.col-2] != '*') &&
	       (matrix[o_pt.row][o_pt.col-3] != '*') &&
	       (o_pt.col-4 >=1))
	    {  ori=2; sel=0;  }
	 }


	 if (sel==3 && ori==2)
	 {
	    if ((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col-1] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col-2] != '*') &&
	       (o_pt.col+4 <=9))
	    {  ori=3; sel=0;  }
	 }

	 if (sel==3 && ori==3)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col+2] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col+3] != '*') &&
	       (o_pt.col-3 >=1))
	    {  ori=4; sel=0;  }
	 }

	 if (sel==3 && ori==4)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row][o_pt.col-1] != '*') &&
	       (matrix[o_pt.row][o_pt.col-2] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col-2] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col-2] != '*') &&
	       (o_pt.col-1 >=1))
	    {  ori=1; sel=0;  }
	 }
	 sel=3;
      }

      if (sel==4)
      {
	 if (sel==4 && ori==1)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col-1] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col-2] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col-3] != '*') &&
	       (o_pt.col-4 >=1))
	    {  ori=2; sel=0;  }
	 }
	 if (sel==4 && ori==2)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col+2] != '*') &&
	       (o_pt.col+3 <=9))
	    {  ori=3; sel=0;  }
	 }
	 if (sel==4 && ori==3)
	 {
	    if((matrix[o_pt.row+1][o_pt.col] != '*') &&
	       (matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+2] != '*') &&
	       (matrix[o_pt.row+1][o_pt.col+3] != '*') &&
	       (o_pt.col+4 <=9))
	    {  ori=4; sel=0;  }
	 }
	 if (sel==4 && ori==4)
	 {
	    if((matrix[o_pt.row][o_pt.col] != '*') &&
	       (matrix[o_pt.row][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-1][o_pt.col+1] != '*') &&
	       (matrix[o_pt.row-2][o_pt.col+1] != '*') &&
	       (o_pt.col-1 >=1))
	    {  ori=1; sel=0;  }
	 }
	 sel=4;

      }
   }/* End UP*/


   if(c=='2')
   {  }
   engine();
}
